//
//  TestOverlayAppDelegate.m
//  TestOverlay
//
//  Created by PhoneyDeveloper on 9/7/08.
//  Copyright __MyCompanyName__ 2008. All rights reserved.
//

#import	<QuartzCore/QuartzCore.h>		// for animations

#import "TestOverlayViewController.h"
#import "TableViewController.h"
#import "ObscuringView.h"

@implementation TestOverlayViewController


- (void)dealloc 
{
	[super dealloc];
}

- (void)viewDidLoad 
{
}

-(IBAction)doOn:(id)sender
{
	NSLog(@"doOn");
	
	CGRect		frame = mTableViewController.tableView.frame;

	[CATransaction begin];
	CATransition *animation = [CATransition animation];
	animation.type = kCATransitionMoveIn;
	animation.subtype = kCATransitionFromTop;

	mObscuringView = [[ObscuringView alloc] initWithFrame:frame];
	
	mObscuringView.alpha = 0.5;
	mObscuringView.backgroundColor = [UIColor blackColor];
	
	[self.view addSubview:mObscuringView];
	[self.view bringSubviewToFront:mObscuringView];
	[self.view setNeedsDisplay];

	// Commit the animation
	[[self.view layer] addAnimation:animation forKey:@"myanimationkey"];
	[CATransaction commit];
}

-(IBAction)doOff:(id)sender
{
	NSLog(@"doOff");
	
	// There doesn't seem to be a way to move the obscuring view off
	// by using a builtin transition.  That seems odd but we move
	// it off by moving the center offscreen.
	// This code doesn't release the obscuring view.  There should
	// be a setAnimationDelegate and setAnimationDidStopSelector
	// where we should release the obscuring view.

	[UIView beginAnimations:nil context:nil];
	[UIView setAnimationCurve:UIViewAnimationCurveLinear];
	
	CGPoint		center = mObscuringView.center;
	
	center.y += [UIScreen mainScreen].bounds.size.height;
	
	mObscuringView.center = center;
	
	[UIView commitAnimations];
}


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}




@end
